module Turtle
   ( Dir(..)
   , Colour(..)
   , T
   , colour
   , size
   , start
   , turn
   , move
   , draw
   , setColour
   , colourAt
   , pixels
   , (|>)
   , for
   , repeat
   ) where

import Prelude hiding (repeat)

data Dir = L | R deriving (Eq, Ord, Show)

data Colour = Black | Red | Green | Blue | Yellow | White
              deriving (Eq, Ord, Bounded, Enum, Show)

data T

start :: Int-> Int-> T
start = undefined

turn :: Dir-> T -> T
turn = undefined

move :: Int -> T-> T
move = undefined

draw :: Int -> T-> T
draw = undefined

-- Farben

colour :: T-> Colour
colour = undefined

setColour :: Colour -> T -> T
setColour = undefined

colourAt :: T-> (Int, Int)-> Colour
colourAt = undefined

-- Gre und Zeichenfeld

size :: T-> (Int, Int)
size = undefined

pixels :: T -> Colour -> Int
pixels = undefined

-- Diese Funktion erlaubt es uns, Sequenzen von Aktionen hinzuschreiben.
(|>) :: T-> (T-> T)-> T
(|>) = flip ($)

-- |> soll nach links binden, strker als ==, aber schwcher als +
infixl 5 |>

-- Zwei ntzliche Kombinatoren:

-- Eine for-Schleife
for :: [a]-> (a-> T-> T)-> T-> T
for as f t = foldl (flip f) t as

-- Wiederholt eine Aktion n-mal
repeat :: Int-> (T-> T)-> T-> T
repeat n f = for [1..n] (\_ t-> f t)

-- Die Show-Instanz ist optional (aber hilfreich beim Testen):
instance Show T where
  show t = "???"

-- Die Show-Instanz kann diese Funktion verwenden, welche 
-- als Argumente die Gre der Zeichenflche, die momentane Position der
-- Turtle, ein Zeichen zur Darstellung der Turtle, sowie die
-- colourAt-Funktion (s. oben) erhlt.
render :: (Int, Int)-> (Int, Int)-> Char-> ((Int, Int)-> Colour)-> String  
render (x, y) pos cchar colAt =    
  unlines [ "\ESC[40m" ++
              concat [ pixelAt (i, j) | i <- [0.. x-1] ] ++
              "\ESC[0m"
            | j <- reverse [0.. y-1] ] where
    pixelAt (i, j) | (i, j) == pos  = "\ESC[0m"++ cchar: "\ESC[40m"
    pixelAt (i, j) | otherwise = case colAt (i, j) of 
      Black -> " "
      Red -> "\ESC[91m#"
      Green  -> "\ESC[92m#"
      Blue   -> "\ESC[96m#"
      Yellow -> "\ESC[93m#"
      White  -> "\ESC[97m#"
  
