module TurtleSpec where


import Test.Tasty
import qualified Test.Tasty.QuickCheck as QC
import Test.Tasty.QuickCheck((==>))
import qualified Test.QuickCheck.Gen as G

import Turtle

-- Arbitrary-Instanz fr Directions
instance QC.Arbitrary Dir where
  arbitrary = G.elements [L, R]

-- Arbitrary-Instanz fr Farben
instance QC.Arbitrary Colour where
  arbitrary = G.elements [minBound .. maxBound]

repeatM :: Monad m=> Int-> (a-> m a)-> a-> m a
repeatM 0 f a = return a
repeatM n f a = f a >>= repeatM (n-1) f

-- Eine zufllige Operation: malen, bewegen, Farbe ndern, drehen.
rndOp :: T-> G.Gen T
rndOp t = 
  G.oneof [ do i<- QC.choose (0,5); return $ move i t
          , do i<- QC.choose (0,5) ; return $ draw i t
          , do c<- QC.arbitrary ; return $ setColour c t
          , do d<- QC.arbitrary ; return $ turn d t 
          ]

-- Arbitrary-Instanz fr die Turtle.
instance QC.Arbitrary T where
  arbitrary = do
    -- Zufllige Gre auswhlen    
    x <- QC.choose (5, 40)
    y <- QC.choose (5, 40)
    -- Bis zu 100 zufllige Operationen
    n <- QC.choose (1,500)
    repeatM n rndOp $ start x y

run = defaultMain $ testGroup "All tests" [tspec, mspec, dspec]

tspec =
  testGroup "Turning" 
    [ -- 3 Tests
    ]


mspec =    
  testGroup "Moving" 
    [ -- 5 Tests
    ]

dspec =
  testGroup "Drawing"
    [ -- ?? Tests
    ]
