module TurtleTest where

import Prelude hiding (repeat)
import Turtle
import TurtleDisplay

line :: T
line = start 20 10 |>  turn L |> setColour Red |> move 5 |> turn R |> turn R |> draw 10

simple :: T
simple = start 20 10 |> turn R |> draw 3 |> setColour Blue
         |> draw 1 |> move 1 |> turn L  |> draw 2 |> turn L
         |> setColour Red |> draw 5

nextCol :: Colour -> Colour
nextCol c = if c == White then Red else succ c

setNextColour :: T -> T
setNextColour t = setColour (nextCol (colour t)) t

spiral :: T
spiral =
   start 40 15 |> 
     for [1.. 12] (\i r-> r |> repeat 2 (\r-> r |> draw i |> turn L) |> setNextColour)

pi3 :: T
pi3 = 
  start 25 9 |> turn L |> move 5 |> turn L |> move 2 |> turn L |> turn L
  |> setColour Yellow
  |> draw 4 |> turn R |> draw 2 |> turn R |> draw 2 |> turn R |> draw 2 
  |> turn L |> move 2 |> turn L |> move 5
  |> setColour Blue
  |> turn L |> draw 5
  |> turn L |> turn L |> move 5 |> turn L |> move 3
  |> setColour Red
  |> draw 2 |> turn L |> draw 4 |> turn L |> draw 3 |> turn L |> move 2
  |> turn L |> move 1 |> draw 2 |> move 2
  
